/***************************************************************************
 *   Copyright (C) 2007 by Marcin Swiechowicz   *
 *   marcin.swiechowicz@gmail.com   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef KDCJOB_H
#define KDCJOB_H

#include <QString>
#include <QObject>
#include <QMap>

class KDialog;

// Lighter version of KJob

class KDCJob: public QObject
{
Q_OBJECT
public:
	KDCJob( QObject *parent = 0 );
	virtual ~KDCJob();
	virtual void start() = 0;
	int totalSize() const;
	virtual int count() const;
	virtual KDialog* dialog() const;
	bool hasErrors();
	void setError( const QString& );
	QString error() const;
	void setFlag( int id, bool flag );
	bool flag( int id );
signals:
	void progress( int progress );
	void infoMessage( const QString& );
	void errorMessage( const QString& );
	void finished( KDCJob * );
	void speed( double );
	void jobTotalSize( int );
	void percent( int val );
	void jobStarted( KDCJob * );
	void jobMainProgram( const QString& );
protected:
	void setTotalSize( int totalSize );
protected:
	int p_totalSize;
	QString p_error;
	QMap<int, bool> p_flags;
};
#endif
