/***************************************************************************
 *   Copyright (C) 2007 by Marcin Swiechowicz   *
 *   marcin.swiechowicz@gmail.com   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef KDCMPLAYERJOB_H
#define KDCMPLAYERJOB_H

#include "kdcjob.h"

#include <QStringList>
#include <QPointer>
#include <QWidget>

#include <KProcess>

class QTimerEvent;

class KDCMPlayerJob: public KDCJob
{
Q_OBJECT
public:
	KDCMPlayerJob( QObject *parent = 0 );
	~KDCMPlayerJob();
	void start();
	void startAndSeek( int ss );
	void setFile( const QString& );
	void setFiles( const QStringList& );
	int currentTime() const;
	void setWindowID( WId id );
	bool isRunning();
	bool isPause();
	int currentMovie() const;
	void setCurrentMovie( int id );
public slots:
	void pause();
	void restart();
	void unpause();
	void forcePause();
	void stop();
	void setSeek( int value );
	void playNext( int id = 1 );
	void playPrev( int id = 1 );
	void setAudioID( int id );
	void setVideoDriver( const QString& );
private slots:
	void on_finished( int , QProcess::ExitStatus );
	void readAllOutput();
	void on_jobStarted();
protected:
	void timerEvent( QTimerEvent *event );
private:
	QPointer<KProcess> p_process;
	QStringList p_files;
	int p_aid;
	int p_timerID;
	int p_curSec;
	WId p_winID;
	QString p_driver;
	int p_id;
};
#endif
 

