/***************************************************************************
 *   Copyright (C) 2007 by Marcin Swiechowicz   *
 *   marcin.swiechowicz@gmail.com   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef KDCREADFILECOMPOSITEJOB_H
#define KDCREADFILECOMPOSITEJOB_H

#include "../kdcdisc.h"
#include "../kdcmovie.h"
#include "../dialogs/kdcprogressdialog.h"
#include "../kdcvideostreammetadata.h"
#include "../kdcaudiostreammetadata.h"
#include "kdccompositejob.h"

#include <QStringList>
#include <QPointer>

class KDCReadFileCompositeJob: public KDCCompositeJob
{
Q_OBJECT
public:
	KDCReadFileCompositeJob( const QStringList& files, KDCDisc *disc, QObject *parent = 0 );
	~KDCReadFileCompositeJob();
	void start();
signals:
	void done( bool );
private slots:
	void on_jobFinished( KDCJob * );
	void on_jobInfoMessage( const QString& );
	void on_jobPercent( int );
	void on_jobDescription( const QString& );
	void on_movieInfo( const QString& , KDCVideoStreamMetaData *, const QList<KDCAudioStreamMetaData*>& );
	void on_noVideoStreamFound();
private:
	QPointer<KDCProgressDialog> p_dlg;
	KDCDisc *p_disc;
	KDCMovie *p_movie;
	int p_totalProgress;
	bool p_data;
};
#endif
