/***************************************************************************
 *   Copyright (C) 2007 by Marcin Swiechowicz   *
 *   marcin.swiechowicz@gmail.com   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef KDCDISCSETTINGS_H
#define KDCDISCSETTINGS_H

#include "kdcnamespace.h"

#include <QObject>

#include <KMenu>
#include <KAction>
#include <KSelectAction>

class KDCDisc;
class QString;

class KDCDiscSettings: public QObject
{
Q_OBJECT
public:
	KDCDiscSettings( KDCDisc *disc );
	~KDCDiscSettings();

	KDC::MediaSize mediaSize() const;

	QString outputPath() const;
	void setOutputPath( const QString& path );

	void setDeleteFilesEnabled( bool enabled );
	bool deleteFilesEnabled();
	void setDeleteTempFilesEnabled( bool enabled );
	bool deleteTempFilesEnabled();
	void setStructureEnabled( bool enabled );
	bool structureEnabled();

	KMenu* menu() const;
signals:
	void mediaSizeChanged();
	void discOutputDirectoryChanged();
private slots:
	void on_mediaSizeChanged();
	void on_setOutputPath();
private:
	QString p_outputPath;
	KDCDisc *p_parent;
	KDC::MediaSize p_mediaSize;
	QMap<KDC::MediaSize, KAction*> p_mediaActions;
	KMenu *p_menu;
	bool p_deleteTempEnabled;
	bool p_deleteEnabled;
	bool p_structureEnabled;
};
#endif
