/***************************************************************************
 *   Copyright (C) 2007 by Marcin Swiechowicz   *
 *   marcin.swiechowicz@gmail.com   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "kdcaudiodelaydelegate.h"

#include <QModelIndex>

#include <KIntSpinBox>

KDCAudioDelayDelegate::KDCAudioDelayDelegate( QObject *parent )
	: QItemDelegate( parent )
{
	
}

QWidget* KDCAudioDelayDelegate::createEditor( QWidget *parent, const QStyleOptionViewItem& option, const QModelIndex& index ) const
{
	KIntSpinBox *editor = new KIntSpinBox( parent );
	connect( editor, SIGNAL( valueChanged( int ) ), this, SLOT( on_delayChanged( int ) ) );
	editor->setRange( -5000, 5000 );
	return editor;
}

void KDCAudioDelayDelegate::setEditorData( QWidget *editor, const QModelIndex& index ) const
{
	int value = index.model()->data( index, Qt::DisplayRole ).toInt();
	KIntSpinBox *tmp = static_cast<KIntSpinBox*>( editor );
	tmp->setValue( value );
}

void KDCAudioDelayDelegate::setModelData( QWidget *editor, QAbstractItemModel *model, const QModelIndex& index) const
{
	KIntSpinBox *tmp = static_cast<KIntSpinBox*>( editor );
	tmp->interpretText();
	model->setData( index, tmp->value() );
}

void KDCAudioDelayDelegate::updateEditorGeometry( QWidget *editor, const QStyleOptionViewItem& option, const QModelIndex& index) const
{
	editor->setGeometry( option.rect );
}

void KDCAudioDelayDelegate::on_delayChanged( int val )
{
	emit delayChanged( val );
}
