/***************************************************************************
 *   Copyright (C) 2007 by Marcin Swiechowicz   *
 *   marcin.swiechowicz@gmail.com   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "kdcvideobitratedelegate.h"

#include "kdcvideobitratespinbox.h"

#include <QModelIndex>

KDCVideoBitrateDelegate::KDCVideoBitrateDelegate( QObject *parent )
	: QItemDelegate( parent )
{
	p_movie = NULL;
}

void KDCVideoBitrateDelegate::setCurrentData( const KDCMovie *movie )
{
	p_movie = movie;
}

QWidget* KDCVideoBitrateDelegate::createEditor( QWidget *parent, const QStyleOptionViewItem& option, const QModelIndex& index ) const
{
	KDCVideoBitrateSpinBox *editor = new KDCVideoBitrateSpinBox( p_movie, parent );
	connect( editor, SIGNAL( valueChanged( int ) ), this, SLOT( on_bitrateChanged( int ) ) );
	return editor;
}

void KDCVideoBitrateDelegate::setModelData( QWidget *editor, QAbstractItemModel *model, const QModelIndex& index) const
{
	KDCVideoBitrateSpinBox *tmp = static_cast<KDCVideoBitrateSpinBox*>( editor );
	model->setData( index, QString::number( tmp->value() ) + " kbps" );
}

void KDCVideoBitrateDelegate::updateEditorGeometry( QWidget *editor, const QStyleOptionViewItem& option, const QModelIndex& index) const
{
	editor->setGeometry( option.rect );
}

void KDCVideoBitrateDelegate::on_bitrateChanged( int bitrate )
{
	emit bitrateChanged( bitrate );
}
