/***************************************************************************
 *   Copyright (C) 2007 by Marcin Swiechowicz   *
 *   marcin.swiechowicz@gmail.com   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef KDCSUBTITLELIST_H
#define KDCSUBTITLELIST_H

#include "../../kdcmovie.h"
#include "../../kdcsubtitlestreamgroup.h"
#include "kdcfpsdelegate.h"
#include "kdctextcodecdelegate.h"
#include "kdctextsizedelegate.h"

#include <QTreeWidget>
#include <QTreeWidgetItem>
#include <QMouseEvent>
#include <QPointer>

class KDCSubtitleList : public QTreeWidget
{
Q_OBJECT
public:
	KDCSubtitleList( QWidget *parent = 0 );
	~KDCSubtitleList();
	void setCurrentMovie( KDCMovie *movie );
	KDCSubtitleStream* currentSubtitleStream() const;
signals:
	void currentSubtitleStreamChanged( KDCSubtitleStream *stream );
public slots:
	void clean();
	void refresh();
private slots:
	void openEditor( QTreeWidgetItem *, int );
	void on_closeEditor( QWidget *, QAbstractItemDelegate::EndEditHint );
	void on_currentItemChanged( QTreeWidgetItem *, QTreeWidgetItem * );
	void on_fpsChanged( double );
	void on_sizeChanged( int );
	void on_codecChanged( const QString& );
protected:
	QStringList mimeTypes() const;
	Qt::DropActions supportedDropActions() const;
	void mouseMoveEvent( QMouseEvent *event );
	bool dropMimeData( QTreeWidgetItem *parent, int index, const QMimeData *data, Qt::DropAction action );
private:
	QPointer<KDCMovie> p_movie;

	KDCTextCodecDelegate *p_codecDelegate;
	KDCTextSizeDelegate *p_sizeDelegate;
	KDCFpsDelegate *p_fpsDelegate;

	int p_id;
};
#endif
