/***************************************************************************
 *   Copyright (C) 2007 by Marcin Swiechowicz   *
 *   marcin.swiechowicz@gmail.com   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef KDCCHAPTEREDITOR_H
#define KDCCHAPTEREDITOR_H

#include "../kdcnamespace.h"
#include "../kdcmovie.h"
#include "../kdcmoviegroup.h"
#include "../jobs/kdcchapterspreviewcompositejob.h"
#include "kdcmplayerwidget.h"

#include <QWidget>
#include <QProgressBar>
#include <QTimeEdit>
#include <QPointer>
#include <QButtonGroup>
#include <QPoint>
#include <QPointer>

#include <KListWidget>
#include <KIntSpinBox>
#include <KPushButton>
#include <KButtonGroup>
#include <KMenu>


class KDCJob;

class KDCChapterEditor: public QWidget
{
Q_OBJECT
public:
	KDCChapterEditor( KDCMPlayerWidget *mediaPlayer, QWidget *parent = 0 );
	~KDCChapterEditor();
	void setCurrentMovie( KDCMovie *movie );
	void setCurrentMovie( KDCMovieGroup *group );
public slots:
	void clean();
private slots:
	void previewFinished( KDCJob * );
	void on_prevAvalible( const QString& , int );
	void refresh();
	void viewModeChanged( int );
	void createPreview();
	void createChapters();
	void getChapterFormPlayer();
	void clearChapters();
	void removeCurrentChapter();
	void showPopupMenu( const QPoint& );
protected:
	void readChapters();
	KDCChapterGroup* currentChapterGroup();
private:
	QPointer<KDCMovie> p_movie;
	QPointer<KDCMovieGroup> p_group;
	KListWidget *p_list;
	QProgressBar *p_jobProgress;
	KIntSpinBox *p_numChapter;
	QTimeEdit *p_timeChapter;
	QPointer<KDCChaptersPreviewCompositeJob> p_job;
	KPushButton *p_stopButton;
	QButtonGroup *p_viewMode;
	KButtonGroup *p_buttonGroup;
	int p_id;
	KDCMPlayerWidget *p_mediaPlayer;
	KMenu *p_popup;
};
#endif
