/***************************************************************************
 *   Copyright (C) 2007 by Marcin Swiechowicz   *
 *   marcin.swiechowicz@gmail.com   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef KDCVIDEOQUALITYCOMBOBOX_H
#define KDCVIDEOQUALITYCOMBOBOX_H

#include "../../kdcnamespace.h"
#include "../../kdcmovie.h"

#include <KComboBox>

class KDCVideoQualityComboBox: public KComboBox
{
Q_OBJECT
public:
	enum Mode { MacroBlock, Deinterlace };
	KDCVideoQualityComboBox( const KDCMovie *movie, KDCVideoQualityComboBox::Mode mode, QWidget *parent = 0 );
	~KDCVideoQualityComboBox();
	KDC::MacroBlockMode currentMacroBlockMode() const;
	KDC::DeinterlaceMode currentDeinterlaceMode() const;
signals:
	void currentMacroBlockModeChanged( KDC::MacroBlockMode mode );
	void currentDeinterlaceModeChanged( KDC::DeinterlaceMode mode );
private slots:
	void on_currentIndexChanged( int );
private:
	KDCVideoQualityComboBox::Mode p_mode;
};
#endif
